package model

import scala.collection.immutable.ArraySeq
import scala.collection.IndexedSeqView

trait HHCTypes {

  /**
    * Graph in mutable adjacency matrix form
    */
  type GraphMatrix[T] = Array[Array[T]]

  /**
    * Graph in mutable adjacency list form
    */
  type MutGraph[T] = Array[Array[HHCEdge2[T]]]

  /**
    * Graph in immutable adjacency list form
    */
  type Graph[T] = ArraySeq[List[HHCEdge2[T]]]

  /**
    * List of removed edges
    */
  type RemovedEdges[T] = List[HHCEdge2[T]]

  type Clusters = ArraySeq[List[Int]]
}
